package com.engine.salary.mapper.taxagent;

import com.engine.salary.entity.taxagent.param.TaxAgentQueryParam;
import com.engine.salary.entity.taxagent.po.TaxAgentEmployeePO;
import com.engine.salary.entity.taxagent.po.TaxAgentPO;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.Collection;
import java.util.List;

public interface TaxAgentMapper {

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<TaxAgentPO> listAll();


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    TaxAgentPO getById(Long id);


    /**
     * 新增，忽略null字段
     *
     * @param taxAgent 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(TaxAgentPO taxAgent);

    /**
     * 修改，修改所有字段
     *
     * @param taxAgent 修改的记录
     * @return 返回影响行数
     */
    int update(TaxAgentPO taxAgent);

    /**
     * 条件查询
     * @param taxAgent
     * @return
     */
    List<TaxAgentPO> listBySome(@Param("param") TaxAgentQueryParam taxAgent);


    /**
     * 根据名称查询
     * @param name
     * @return
     */
    @Select("SELECT * FROM hrsa_tax_agent WHERE delete_type = 0 and name = #{name}")
    List<TaxAgentPO> listByName(String name);

    /**
     * 批量删除个税扣缴义务人
     *
     * @param ids
     */
    void deleteByIds(@Param("ids") Collection<Long> ids);

    List<TaxAgentEmployeePO> listEmployee();

}